//新修订的版本,增加对象和方法的判断
var slardarBridge = {};

slardarBridge.checkUsedFull = function (value) {
    return typeof value !== "undefined" && value !== null && value !== "";
};

slardarBridge.isFunction = function (what) {
    return typeof what === 'function';
};

slardarBridge.appendCommonParams = function (dataObj) {
    dataObj.path = location.pathname;
    dataObj.url = location.href;
    dataObj.host = location.hostname;
};

slardarBridge.cover = function (dataObj, serviceStr) {
    if (!slardarBridge.checkUsedFull(dataObj)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.cover)) {
        return;
    }
    slardarBridge.appendCommonParams(dataObj);
    dataObj.service = serviceStr;
    var dataJson = JSON.stringify(dataObj);
    iesJsBridgeTransferMonitor.cover(dataJson, serviceStr);
};

slardarBridge.accumulate = function (dataObj, serviceStr) {
    if (!slardarBridge.checkUsedFull(dataObj)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.accumulate)) {
        return;
    }
    slardarBridge.appendCommonParams(dataObj);
    dataObj.service = serviceStr;
    var dataJson = JSON.stringify(dataObj);
    iesJsBridgeTransferMonitor.accumulate(dataJson, serviceStr);
};

slardarBridge.reportDirectly = function (dataObj, serviceStr) {
    if (!slardarBridge.checkUsedFull(dataObj)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.reportDirectly)) {
        return;
    }
    slardarBridge.appendCommonParams(dataObj);
    dataObj.service = serviceStr;
    var dataJson = JSON.stringify(dataObj);
    iesJsBridgeTransferMonitor.reportDirectly(dataJson, serviceStr);
};

slardarBridge.average = function (dataObj, serviceStr) {
    if (!slardarBridge.checkUsedFull(dataObj)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.average)) {
        return;
    }
    slardarBridge.appendCommonParams(dataObj);
    dataObj.service = serviceStr;
    var dataJson = JSON.stringify(dataObj);
    iesJsBridgeTransferMonitor.average(dataJson, serviceStr);
};

slardarBridge.diff = function (dataObj, serviceStr) {
    if (!slardarBridge.checkUsedFull(dataObj)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.diff)) {
        return;
    }
    dataObj.service = serviceStr;
    var dataJson = JSON.stringify(dataObj);
    iesJsBridgeTransferMonitor.diff(dataJson, serviceStr);
};


slardarBridge.sendInitTimeInfo = function (dataJson) {
    if (!slardarBridge.checkUsedFull(dataJson)
        || !slardarBridge.checkUsedFull(iesJsBridgeTransferMonitor)
        || !slardarBridge.isFunction(iesJsBridgeTransferMonitor.sendInitTimeInfo)) {
        return;
    }
    iesJsBridgeTransferMonitor.sendInitTimeInfo(dataJson);
};

window.jsIESLiveTimingMonitor = slardarBridge;

//add listener to notify init time
window.addEventListener("DOMContentLoaded", function () {
    window.setTimeout(function () {
        if (window.history.length <= 1) {
            var time = new Date().getTime() - performance.timing.navigationStart;
            time = time > 0 ? parseInt(time) : 0;
            slardarBridge.sendInitTimeInfo(time + "")
        }
    }, 0);
});